#!/usr/bin/env python
import SEP.solver
import SEP.cgstep
import SEP.superset
import SEP.spawn
import SEP.par
import string
import SEP.sep_vector
import sys
SEP.util.debug=1


args=SEP.par.sep_args() #get arguments
dname,err1=args.par("data")
mname,err2=args.par("model")
if err1==0 or err2==0: SEP.util.err("Must provide model and data")

data =SEP.sep_vector.sfloat(tag=dname)
model=SEP.sep_vector.sfloat(name=mname)
model.add_history_par("n1",200)
model.add_history_par("o1",0.)
model.add_history_par("d1",.4)
model.write_file()
model.zero()


interp_args=SEP.par.sep_pars(name="interp")
interp_args.add_param("coord","coord.H")
interp_args.add_param(">","/dev/null")

regprec=SEP.par.sep_pars(name="devnull")
regprec.add_param(">","/dev/null")
regprec.add_param("filter",2)

interp=SEP.operator.oc("Interp1.x",model,data,pars=interp_args)

reg=SEP.operator.oc("reg.x",model,model,pars=regprec)
prec=SEP.operator.oc("prec.x",model,model,pars=regprec)

                                                                                   
step=SEP.cgstep.cgstep("matcg")


                                                                                
#solver=SEP.solver.reg("interp1d",model,data,interp,reg,step,10,.1,verb=1)
solver=SEP.solver.prec("interp1d",model,data,interp,prec,step,20,.1,verb=1)
#solver=SEP.solver.prec("interp1d",model,data,interp,prec,step,1,.1,verb=0)
if not solver.solve():
  SEP.util.err( "Trouble iterating")
solver.clean()
